package bitsUnited;

/*
 $Id: AbsolutBall.java,v 1.4 2002/07/07 11:28:28 dd Exp $
 $Log: AbsolutBall.java,v $
 Revision 1.4  2002/07/07 11:28:28  dd
 fuer den Ball distChange und dirchange eingebaut. in AbsolutBall zusaetzliche Positionsveraenderung
 verfuegbar ueber getPosCh_X() bzw. getPosCh_y()
 CV : ----------------------------------------------------------------------

 Revision 1.3  2002/07/02 23:47:27  ju
 package von robocop in bitsUnited umbenannt; mehr nicht...

 Revision 1.2  2002/05/29 18:26:36  dd
 Erste Version

 */


/**
 * The <code>AbsolutBall</code> class is used as a representation of
 * the ball in absolut context.
 * The class is updated by the <code>Weltmodell</code> if with a new
 * see-Message the Object is still visible. Otherwise the Object may be
 * "interpolated" according to its last movement as long as the timestamp
 * did not go to far.
 *
 * @author <a href="mailto:dedietri@uni-mannheim.de">Dennis Dietrich</a>
 * @version 0.1
 */
public class AbsolutBall extends AbsolutFieldObject {
    
    private float posch_x, posch_y;

    /**
     * Creates a new <code>AbsolutBall</code> instance.
     * Since the Ball is unique on the Field, no additional information
     * is needed, so we simply call <code>super(x,y,timestamp)</code>
     * @see AbsolutFieldObject
     * @see AbsolutSpieler
     */
    public AbsolutBall(float x, float y, int timestamp) {
	super( x, y, timestamp );
    }

    public AbsolutBall(float x, float y, int timestamp, float poschx, float poschy ){
	super ( x, y, timestamp );
	this.posch_x = poschx;
	this.posch_y = poschy;
    }

    /**
     * sets a new value for the posch_x attribute
     * @param poscx the new value for possch_x
     */
    public void setPosCh_X( float poscx ) {
	this.posch_x = poscx;
    }

    /**
     * sets a new value for the posch_y attribute
     * @param poscy the new value for posch_y
     */
    public void setPosCh_Y( float poscy ) {
	this.posch_y = poscy;
    }

    /**
     * returns the posch_x attribute
     */
    public float getPosCh_X() {
	return posch_x;
    }

    /**
     * returns the posch_y attribute
     */
    public float getPosCh_Y() {
	return posch_y;
    }

    /**
     * Returns the type of <code>AbsolutFieldObject</code>
     * Overwrites the <code>getType()</code> method of 
     * <code>AbsolutFieldObject</code>. Returns the constant value
     * <code>AbsolutFieldObject.BALL</code>
     * 
     * @see AbsolutBall
     * @see AbsolutSpieler
     */
    public int getType() {
	return BALL;
    }
  
}


