package bitsUnited;

/*
 $Id: AbsolutSpieler.java,v 1.4 2002/07/02 23:47:27 ju Exp $
 $Log: AbsolutSpieler.java,v $
 Revision 1.4  2002/07/02 23:47:27  ju
 package von robocop in bitsUnited umbenannt; mehr nicht...

 Revision 1.3  2002/05/31 18:20:09  dd
 Weltmodell implementiert und RelativFieldObjects angepasst.

 Revision 1.2  2002/05/29 18:26:36  dd
 Erste Version

 */

/**
 * The <code>AbsolutSpieler</code> class is used as a representation of
 * a player in absolut context.
 * The class is updated by the <code>Weltmodell</code> if with a new
 * see-Message the Object is still visible. Otherwise the Object may be
 * "interpolated" according to its last movement as long as the timestamp
 * did not go to far.
 *
 * @author <a href="mailto:dedietri@uni-mannheim.de">Dennis Dietrich</a>
 * @version 0.1
 */
public class AbsolutSpieler extends AbsolutFieldObject {
    
    /** the players number */
    private int spielerNum;
 
    /** does he belong to our own team */
    private String teamName;

    /**
     * Creates a new <code>AbsolutSpieler</code> instance.
     * As additional information we need the players number whether it belongs 
     * to our team or not. Besides x,y and timestamp are needed.
     * @see AbsolutFieldObject
     * @see AbsolutSpieler
     */
    public AbsolutSpieler( float x, float y, int timestamp, 
                           int spielerNum, String teamName ) {
	super( x, y, timestamp );
        this.spielerNum = spielerNum;
        this.teamName = teamName;
    }

    /**
     * Returns the type of <code>AbsolutFieldObject</code>
     * Overwrites the <code>getType()</code> method of 
     * <code>AbsolutFieldObject</code>. Returns the constant value
     * <code>AbsolutFieldObject.SPIELER</code>
     * 
     * @see AbsolutBall
     * @see AbsolutFieldObject
     */
    public int getType() {
	return SPIELER;
    }

    /** 
     * Returns the players number as given on construction of the instance.
     */
    public int getSpielerNum() {
	return spielerNum;
    }

    /**
     * Returns true if the player belongs to our own Team
     */
    public String getTeamName() {
	return teamName;
    }  
}






