package bitsUnited;

/*
        $Id: OlliKahn.java,v 1.24 2002/07/07 23:09:15 mj Exp $
        $Log: OlliKahn.java,v $
        Revision 1.24  2002/07/07 23:09:15  mj
        ...final version... may the force be with u...

        Revision 1.23  2002/07/07 21:32:06  dd
        vorlufiger Endstand

        Revision 1.21  2002/07/07 19:30:20  mj
        ...catchdir...

        Revision 1.19  2002/07/07 17:08:26  mj
        *** ueberarbeitet ***

        Revision 1.16  2002/07/06 22:28:36  ju
        ...noch ohne predict der ballpos...
 
        Revision 1.15  2002/07/05 16:50:44  ju
        ...dasht nur noch mit 80...
 
        Revision 1.14  2002/07/04 23:11:28  ju
        genauere playmodi-beachtung (wg stamina),
        flanke statt torschuss bei zu engem winkel,
        warten beim anstoss
 
        Revision 1.13  2002/07/04 22:15:28  ju
        NullPointerException bei Positionsbestimmung wird ge"catch"t
 
        Revision 1.11  2002/07/03 20:28:30  ju
        ...Spieler laufen nur noch max einen halben Meter hinter die Spielfeldmakierung und somit (hoffentlich) nicht mehr aus dem Bildschirm...
 
        Revision 1.10  2002/07/03 19:32:17  ju
        (noch) keine Aktivitaeten bei BEFORE_KICK_OFF
 
        Revision 1.9  2002/07/03 14:58:45  ju
        ...ueberarbeitet...
 
        Revision 1.8  2002/07/03 10:55:00  ju
        weiter ueberarbeitet, insb. headAngle-beachtung und playmodi
 
        Revision 1.7  2002/07/02 23:47:27  ju
        package von robocop in bitsUnited umbenannt; mehr nicht...
 
        Revision 1.6  2002/06/27 19:09:31  ju
        neue methoden in Strategy
 
        Revision 1.5  2002/06/27 15:40:26  mj
        Aenderungen vom Do 27.
 
        Revision 1.4  2002/06/27 09:05:31  ju
        --- achtung: headAngle mitbeachten ---
 
        Revision 1.3  2002/06/26 14:34:35  ju
        kleine aenderung
 
        Revision 1.2  2002/06/24 22:36:27  ju
        erneute aenderungen beim winkelberechnen
 
        Revision 1.1  2002/06/23 23:58:04  ju
        torwart; vorerst nur geruest fuer testzwecke
 
 */

import java.util.*;

/**
 * The <code>OlliKahn</code> class describes the behavior of a goalie.
 *
 * @author <a href="mailto:mail@jojo4ever.de">Johannes Uihlein</a>
 * @version 0.1
 */
public class OlliKahn extends Strategy {
    
    // Strafraum:
    //		(-52.5,-19)		(-37,-19)
    //		(-52.5,19)		(-37,19)
    
    
    // 5-Meterraum:
    //		(-52.5,-9)		(-47,-9)
    //		(-52.5,9)		(-47,9)
    
    
    // Tor:
    //		(-52.5,-7.01)
    //		(-52.5,7.01)
    
    
    /**
     * this method overwrites the standard init()-method of <code>Strategy</code>
     *	for field players with the one for the goalie.
     */
    public void init() {
        this.myPlayer.init_goalie();
    }
    
    
    /** this method calls the players actions in dependancy of the playing circumstances */
    public void makeDecision() {
        
        /** the position of the player */
        Position myPos = new Position();
        
        /** the start position of the player */
        Position myStartPos = new Position();
        
        //die Position des Balls
        Position ballPos = new Position();
        
        //eine moegliche zukuenftige Position des Balls
        Position ballNextPos = new Position();
        
        // die Entfernung zwischen Torwart und Ball
        float ballDist = -1;
        
        // die Entfernung zwischen Torwart und der moeglichen nexten Position des Balls
        float ballNextDist = -1;
        
        //die Richtung (vom Torwart aus), in der der Ball liegt
        float ballDir = 0;
        
        //die Richtung (vom Torwart aus), in der der Ball moeglicherweise liegen wird
        float ballNextDir = 0;
        
        //die Entfernung zwischen einem ausgewaehlten Spieler und dem Tor
        float playerGoalDist = -1;
        
        //die Entfernung zwischen einem ausgewaehlten Spieler und dem Ball
        float playerBallDist = -1;
        
        //die Entfernung zwischen einem ausgewaelten Spieler und Torwart
        float playerDistToMe = -1;
        
        //die Richtung, in der ein anspielbarer Mitspieler ist
        float availTmDir = 0;
        
        //die Entfernung zwischen Torwart und dem nahesten Mitspieler
        float closestTmDistToMe = -1;
        
        //die Richtung, in der der nahesten Mitspieler steht
        float closestTmDirToMe = 0;
        
        //die Entfernung zwischen Torwart und dem zweitnahesten Mitspieler
        float secClosestTmDistToMe = -1;
        
        //die Richtung, in der der zweitnahesten Mitspieler steht
        float secClosestTmDirToMe = 0;
        
  /** direction to start position */
        float startPosDir = 0;
        
        /** distance from start position */
        float startPosDist = -1;
        
        //true, wenn der Torwart die Position des Balls kennt
        boolean foundBall = false;
        
        //true, wenn der Ball im spielbaren Umfeld des Torwarts liegt
        boolean ballInRange = false;
        
        //true, wenn der Ball im spielbaren Umfeld des Torwarts liegt
        boolean ballInCatchRange = false;
        
        //true, wenn der nue errechnete Ball im spielbaren Umfeld des Torwarts liegt
        boolean ballNextInRange = false;
        
        //true, wenn der neu errechnete Ball im spielbaren Umfeld des Torwarts liegt
        boolean ballNextInCatchRange = false;
        
        //true, wenn der Torwart der naheste Mitspieler am Ball ist
        boolean amNearestTmToBall = false;
        
        //die Richtung, in der der naheste Gegner steht
        float closestOppDir;
        
        //die Richtung, in der der zweitnaheste Gegner steht
        float secClosestOppDir;
        
        //die Richtung, in der kein Gegner stehen sollte
        float freeDir = 0;
        
        float y_t = 0;
        
        float bDiffX = 0;
        
        float bDiffY = 0;
        
        try {
            myPos.setX(myPlayer.getMyPos().getX());
            myPos.setY(myPlayer.getMyPos().getY());
        }
        catch (NullPointerException e) {
            myPlayer.turnBody(110);
            myPlayer.turnHead(-myPlayer.getHeadAngle());
            myPlayer.setPlayStatus(myPlayer.EXCEPTION);
        }
        
        myStartPos.setX(myPlayer.getMyStartPos().getX());
        myStartPos.setY(myPlayer.getMyStartPos().getY());
        
        if ( myPos.getY() > 20) {
            freeDir = -25;
        }
        if ( myPos.getY() < -20 ) {
            freeDir = 25;
        }
        
        float MPDir = dir(0, 0, myPos.getX(), myPos.getY());
        
        //setzte nach aktuallisierung des Weltmodells (in Klasse Player geschehen) meine obigen Variablen
        switch (myPlayer.getPlayStatus()) {
            
            case Player.EXCEPTION:
            {
                break;
            }
            
            case Player.BEFORE_KICK_OFF:
            case Player.KICK_OFF_MYTEAM:
            case Player.KICK_OFF_OPP:
            {
                if ( myPos.getX()<=(myStartPos.getX()+0.5f) && myPos.getX()>=(myStartPos.getX()-0.5f) &&
                myPos.getY()<=(myStartPos.getY()+0.5f) && myPos.getY()>=(myStartPos.getY()-0.5f)) {
                    
                    if ((myPlayer.getBodyAngle()-MPDir>2) || (myPlayer.getBodyAngle()-MPDir<(-2))) {
                        turnBodyTo(MPDir); if (myPlayer.getReceivedSeeHead()) myPlayer.turnHead(-myPlayer.getHeadAngle());
                    }
                }
                else {
                    myPlayer.move( (int)myStartPos.getX(), (int)myStartPos.getY() );
                }
                break;
            }
            
            default: // also auch CORNER_KICK,...
            {
                
                // Entfernung des Spieler zu seiner Start-Position wird berechnet (Pythagoras)
                startPosDist = dist(myStartPos.getX(), myStartPos.getY(), myPlayer.getMyPos().getX(), myPlayer.getMyPos().getY());
                
                // die Richtung des Balles vom Spieler wird errechnet (tan x = y => x = atan y)
                // Wertebereich: [-180; 180]
                startPosDir =  dir(myStartPos.getX(), myStartPos.getY(), myPlayer.getMyPos().getX(), myPlayer.getMyPos().getY());
                
                //ziehe die AbsolutFieldObjects aus der Liste
                for (Enumeration aenum = myPlayer.getWeltmodell().getKnownObjects().elements() ; aenum.hasMoreElements() ;) {
                    AbsolutFieldObject atemp = (AbsolutFieldObject) aenum.nextElement();
                    
                    switch (atemp.getType()) {
                        case AbsolutFieldObject.BALL: {
                            
                            AbsolutBall aball = (AbsolutBall) atemp;
                            
                            // Ball ist im Weltmodell
                            foundBall = true;
                            
                            // aktuelle Position des Balles wird gespeichert
                            ballPos.setX(aball.getX());
                            ballPos.setY(aball.getY());
                            
                            // Vorherbestimmung der Position des Balles anhand der letzten bekannten Position
                            ballNextPos.setX(aball.getX()+(5*aball.getPosCh_X()));
                            ballNextPos.setY(aball.getY()+(5*aball.getPosCh_Y()));
                            
//                          System.out.println("delta_x: "+aball.getPosCh_X());
//                          System.out.println("delta_y: "+aball.getPosCh_Y());
                            
                            // Entfernung des Balles zu sich selbst wird berechnet (Pythagoras)
                            ballDist = dist(ballPos.getX(), ballPos.getY(), myPlayer.getMyPos().getX(), myPlayer.getMyPos().getY());
                            
                            // moegliche zukuenftige Entfernung des Balles zum Spieler wird berechnet (Pythagoras)
                            ballNextDist = dist(ballNextPos.getX(), ballNextPos.getY(), myPlayer.getMyPos().getX(), myPlayer.getMyPos().getY());
                            
                            // ist Ball in Reichweite
                            if ( ballDist < 0.85f ) { ballInRange = true; }
                            else { ballInRange = false; }
                            
                            // ist Ball in Reichweite
                            if ( ballDist < 1.5f ) { ballInCatchRange = true; }
                            else { ballInCatchRange = false; }
                            
                            // ist Ball in Reichweite
                            if ( ballNextDist < 0.85f ) { ballNextInRange = true; }
                            else { ballNextInRange = false; }
                            
                            // ist Ball in Reichweite
                            if ( ballNextDist < 1 ) { ballNextInCatchRange = true; }
                            else { ballNextInCatchRange = false; }
                            
                            // die Richtung des Balles wird errechnet (tan x = y => x = atan y)
                            // Wertebereich: [-180; 180]
                            ballDir = dir(ballPos.getX(), ballPos.getY(), myPlayer.getMyPos().getX(), myPlayer.getMyPos().getY());
                            
                            // die Richtung des Balles vom Spieler wird errechnet (tan x = y => x = atan y)
                            // Wertebereich: [-180; 180]
                            ballNextDir = dir(ballNextPos.getX(), ballNextPos.getY(), myPlayer.getMyPos().getX(), myPlayer.getMyPos().getY());
                            
                            break;
                        }
                        
                        case AbsolutFieldObject.SPIELER: {
                            
                            AbsolutSpieler aspieler = (AbsolutSpieler) atemp;
                            
                            if (foundBall) {
                                // Entfernung des gefundenen Spieler zum Ball wird berechnet (Pythagoras)
                                playerBallDist = dist(aspieler.getX(), aspieler.getY(), ballPos.getX(), ballPos.getY());
                            }
                            
                            // Entfernung des gefundenen Spieler zum eigenen Tor wird berechnet (Pythagoras)
                            playerGoalDist = dist(aspieler.getX(), aspieler.getY(), -52.5f, 0);
                            
                            // ist ein Mitspieler??
                            if ( myPlayer.getMyTeamName().equals(aspieler.getTeamName()) ) {
                                
                                //  wer ist naeher am Ball??
                                if (amNearestTmToBall) {
                                    if ( playerBallDist < ballDist ) amNearestTmToBall = false;
                                    else amNearestTmToBall = true;
                                }
                            }
                            
                            break;
                        } // Ende SPIELER
                    } // Ende switch
                } // Ende for enumeration
            } // Ende case PLAY_ON
        } // Ende switch playStatus
        
        // ------------------- Aktivitaetsdiagramm "Torwart" ---------------------
        
        //System.out.println("myPos: ("+myPlayer.getMyPos().getX()+","+myPlayer.getMyPos().getY()+")");
        //System.out.println("BodyAngle: "+myPlayer.getBodyAngle());
        //System.out.println("founBall: "+foundBall);
        //System.out.println("ballPos: ("+ballPos.getX()+","+ballPos.getY()+")");
        //System.out.println("ballDir: "+ballDir);
        //System.out.println("ballDist: "+ballDist);
        
        if (myPos.getX() > 53 || myPos.getX() < -53 || myPos.getY() > 34.5f || myPos.getY() < -34.5f) {
            if ((myPlayer.getBodyAngle()-MPDir>2) || (myPlayer.getBodyAngle()-MPDir<(-2))) {
                turnBodyTo(MPDir);
            }
            else myPlayer.dash(100);
        }
        else {
            
            switch (myPlayer.getPlayStatus()) {
                
                default:
                {
                    if ( myPlayer.getPlayTime()>0 && myPlayer.getPlayTime()<=6000 ) {
                        if (foundBall && ballPos.getX()<5) {
                            if (ballNextInCatchRange) {
                                if (ballInRange) {
                                    kickTo(100, 0);
                                }
                                else {
                                    myPlayer.catchBall(ballNextDir);
                                }
                            }
                            else {
                                if ( ballPos.getX()<=-42 && ballPos.getY()<=12 && ballPos.getY()>=-12 ) {
                                    // gehe zu Ball
                                    if ( ((myPlayer.getBodyAngle()-ballDir))>=(-2) && ((myPlayer.getBodyAngle()-ballDir)<=2) ) {
                                        if (ballDist>2) {
                                            myPlayer.dash(100);
                                        }
                                        else {
                                            myPlayer.dash(80);
                                        }
                                    }
                                    else {
                                        turnBodyTo(ballDir);
                                        if ((myPlayer.getHeadAngle()>1 || myPlayer.getHeadAngle()<-1) && myPlayer.getReceivedSeeHead()) myPlayer.turnHead(-myPlayer.getHeadAngle());
                                    }
                                }
                                else {
                                    if (ballDist<50) {
                                        if (ballNextPos.getY()<=7 && ballNextPos.getY()>=-7) {
                                            if ( goTo(myStartPos.getX(), ballNextPos.getY(), 1) ) {
                                                turnHeadTo(ballDir);
                                            }
                                        }
                                        else {
                                            if (ballNextPos.getY()>0) {
                                                if ( goTo(myStartPos.getX(), 5, 1) ) {
                                                    turnHeadTo(ballDir);
                                                }
                                            }
                                            else {
                                                if ( goTo(myStartPos.getX(), -5, 1) ) {
                                                    turnHeadTo(ballDir);
                                                }
                                            }
                                        }
                                    }
                                    else {
                                        goTo(myStartPos.getX(), myStartPos.getY(), 1);
                                    }
                                }
                            }
                        }
                        else {
                            if (!foundBall) {
                                if (myPlayer.getBodyAngle()>80 || myPlayer.getBodyAngle()<-80) {
                                    turnBodyTo(0);
                                }
                                searchBallWalk();
                            }
                            else {
                                turnHeadTo(ballDir);
                            }
                        }
                    }
                    break;
                }
                
                case Player.GOAL_KICK_MYTEAM:
                {
                    if (foundBall) {
                        if (ballInRange) {
                            if (myPos.getY()>0) {
                                kickTo(100, -35);
                            }
                            else {
                                kickTo(100, 35);
                            }
                        }
                        else {
                            // gehe zu Ball
                            if ( ((myPlayer.getBodyAngle()-ballDir))>=(-3) && ((myPlayer.getBodyAngle()-ballDir)<=3) ) {
                                if (ballDist>2) {
                                    myPlayer.dash(100);
                                }
                                else {
                                    myPlayer.dash(80);
                                }
                            }
                            else {
                                turnBodyTo(ballDir);
                                if (myPlayer.getReceivedSeeHead()) myPlayer.turnHead(-myPlayer.getHeadAngle());
                            }
                        }
                    }
                    else {
                        if (myPlayer.getBodyAngle()-dir(-47, 9, myPos.getX(), myPos.getY())<=2 && myPlayer.getBodyAngle()-dir(-47, 9, myPos.getX(), myPos.getY())>=-2) {
                            turnBodyTo(dir(-47, -9, myPos.getX(), myPos.getY()));
                        }
                        else {
                            turnBodyTo(dir(-47, 9, myPos.getX(), myPos.getY()));
                        }
                        if (myPlayer.getReceivedSeeHead()) myPlayer.turnHead(-myPlayer.getHeadAngle());
                    }
                    break;
                }
                
                case Player.CORNER_KICK_OPP:
                {
                    if (startPosDist>2) { goTo(myStartPos.getX(), myStartPos.getY(), 1); }
                    else {
                        if ((myPlayer.getHeadAngle()>1 || myPlayer.getHeadAngle()<-1) && myPlayer.getReceivedSeeHead()) myPlayer.turnHead(-myPlayer.getHeadAngle());
                        if ( (myPlayer.getBodyAngle()-dir(52, -34, myPos.getX(), myPos.getY())>2) ||
                        (myPlayer.getBodyAngle()-dir(52, -34, myPos.getX(), myPos.getY())<-2) ) {
                            turnBodyTo(dir(52, -34, myPos.getX(), myPos.getY()));
                        }
                        else {
                            turnBodyTo(dir(52, 34, myPos.getX(), myPos.getY()));
                        }
                    }
                    break;
                }
                
                case Player.CORNER_KICK_MYTEAM:
                case Player.GOAL_KICK_OPP:
                case Player.KICK_IN_MYTEAM:
                case Player.KICK_IN_OPP:
                case Player.KICK_OFF_MYTEAM:
                case Player.KICK_OFF_OPP:
                case Player.FREE_KICK_MYTEAM:
                case Player.FREE_KICK_OPP:
                {
                    if (startPosDist>2) { goTo(myStartPos.getX(), myStartPos.getY(), 1); }
                    else {
                        turnBodyTo(0);
                        if ((myPlayer.getHeadAngle()>1 || myPlayer.getHeadAngle()<-1) && myPlayer.getReceivedSeeHead()) myPlayer.turnHead(-myPlayer.getHeadAngle());
                    }
                    break;
                }
                
                case Player.EXCEPTION:
                case Player.BEFORE_KICK_OFF:
                {
                    break;
                }
                
            }
        }
    }
}