package bitsUnited;

import java.util.*;
import java.lang.*;

/*
   $Id: Parser.java,v 1.37 2002/07/07 23:06:16 mj Exp $
   $Log: Parser.java,v $
   Revision 1.37  2002/07/07 23:06:16  mj
   ...final version... may the force be with u...

   Revision 1.36  2002/07/07 11:28:28  dd
   fuer den Ball distChange und dirchange eingebaut. in AbsolutBall zusaetzliche Positionsveraenderung
   verfuegbar ueber getPosCh_X() bzw. getPosCh_y()
   CV : ----------------------------------------------------------------------

   Revision 1.34  2002/07/07 10:05:46  dd
   *** empty log message ***

   Revision 1.33  2002/07/07 09:28:46  mj
   distChange und DirChange beim Ball eingebaut

   Revision 1.32  2002/07/06 12:29:50  mj
   exceptions werden nicht mehr ausgegeben

   Revision 1.31  2002/07/05 20:28:35  dd
   kleine nderungen, Verbesserung beim Winkel im Weltmodell
 
   Revision 1.30  2002/07/04 20:39:39  mj
   javadoc
 
   Revision 1.28  2002/07/03 18:21:11  as
   Buffergre beim ServerConnector auf 2048 vergrert.
   Parser: Kommentare erweitert. Routinen bei den
   see-Nachrichrichten (Linie, Player) gefixt.
 
   Revision 1.27  2002/07/03 00:49:45  as
   Umfangreiche nderungen im Bereich der hear-Nachrichten.
   'Serverfehler' ('-') werden ab sofort bercksichtigt.
   parseInt bzw. parseFloat anstatt valueOf.
   Weitere Bugs behoben.
 
   Revision 1.25  2002/06/30 21:22:48  ju
   playmodi bei goal_l / goal_r auf BEFORE_KICK_OFF geaendert (z. 652)
 
   Revision 1.24  2002/06/28 11:09:02  mj
   die Spielestaten sollten jetzt endlich richtig erkannt werden
 
   Revision 1.23  2002/06/27 15:40:01  mj
   no message
 
   Revision 1.21  2002/06/26 14:24:14  mj
   die Fehlermeldungen kommen jetzt praezieser
   body Nachrichten mit Konstruktor abgestimmt
 
   Revision 1.20  2002/06/26 07:50:17  dd
   Visualisierung verbessert
 
   Revision 1.19  2002/06/25 16:57:27  as
   Einige Bugs behoben, u.a. im Tor-Bereich. Weiterhin werden
   aus den gesehenen Toren jetzt Fahnen erzeugt.
 
   Revision 1.18  2002/06/23 21:39:14  mj
   einen Bug bei den Fahnen gefunden und behoben
 
   Revision 1.16  2002/06/23 14:38:01  mj
   no message
 
   Revision 1.15  2002/06/22 21:50:46  mj
   playStatus wird aktualisiert und Bugs bei see-Nachrichten behoben
 
   Revision 1.14  2002/06/21 14:35:13  mj
   bei init den boolean hinzugefuegt
 
   Revision 1.13  2002/06/20 22:52:28  dd
   Weltmodell funktioniert, Parser gefixt, Client lauffhig
 
   Revision 1.12  2002/06/20 16:06:42  dd
   Stand nach unserem "Get-together" Treffen
 
   Revision 1.11  2002/06/18 23:10:36  as
   hear-Nachrichten werden ab sofort erkannt.
   Neue Kommentare hinzugefgt.
   Einige Bugs entfernt.
 
   Revision 1.10  2002/06/18 14:51:59  mj
   neue Fallunterscheidung bei dist, dir, ...
 
   Revision 1.8  2002/06/12 14:50:33  mj
   see Nachrichten abgehakt
 
   Revision 1.7  2002/06/11 20:39:24  mj
   sene_body Nachrichten knnen (endlich) geparst werden
 
 */

/**
 *  The class <code>Parser</code> cuts up to pieces the server messages and extracts the relevant informations
 *   for further usage.
 */
public class Parser{
    
    /** constant integer representing the message type "error"
     */
    public static final int ERRMSG  = 0;
    /** constant integer representing the message type "init"
     */
    public static final int INITMSG = 1;
    /** constant integer representing the message type "see"
     */
    public static final int SEEMSG  = 2;
    /** constant integer representing the message type "sense_body"
     */
    public static final int BODYMSG = 3;
    /** constant integer representing the message type "hear"
     */
    public static final int HEARMSG = 4;
    /** constant integer representing the message type "referee"
     */
    public static final int REFMSG  = 5;
    
    private int         timeStamp   = 0; // Zeitstempel der empfangenen Nachricht
    
    /** the boolean is true if our team plays from left to right
     */
    private      boolean     left2right  = false; // Spielrichtung
    
    /** represents the play modes of the simulation server. Default value: "before_kick_off"
     *  @see Player
     */
    private      int         playModi    = Player.BEFORE_KICK_OFF; // Spielmodus
    
    /** number of our scores
     */
    private      int         myScore     = 0; // die von mir geschossenen Tore
    
    /** number of opposite scores
     */
    private      int         oppScore    = 0; // die vom Gegner erzielten Tore
    
    
    private static      Vector      objVector;  //zum Abspeichern von VisualNachrichten
    private static      BodyObject  bodyObject; // zum Abspeichern der Spielerinformationen
    
    /** Sole construktor */
    public Parser() {
    }
    
    /** The Method parseMsg() gets an object of the class String, divides it and generates acording to the
     *      message type an object of the class <code>RelativFieldObject</code> or
     *      <code>BodyObject</code>. At the end the method returns the message ID as an Integer.
     */
    public int parseMsg(String msg) {
        
        int msgID = ERRMSG;
        
        float distance = 0;
        float angle = 0;
        
        // erzeuge einen StringTokenizer aus der Nachricht
        StringTokenizer st = new StringTokenizer(msg);
        
        try {
            // Nachrichtentyp herausfiltern
            String s = st.nextToken("( ");
            //System.out.println("s = " + s); // zum Testen
            
            // see-Nachricht
            if(s.equals("see")){
                
                // neuen Vector fr RelativFieldObjects erzeugen
                objVector = new Vector();
                
                // Nachrichtentyp fuer den Player festlegen
                msgID = SEEMSG;
                // bei der see Nachricht wird die Zeit (timeStamp) herausgezogen
                String time = st.nextToken().trim();
                if( time.endsWith(")") ){
                    timeStamp = Integer.parseInt(time.replace(')', ' ').trim());
                }
                else{
                    timeStamp = Integer.parseInt(time);
                }
                //System.out.println("Time =" + timeStamp); // zum Testen
                
                // finde heraus, was gesehen wird
                while (st.hasMoreTokens()){
                    try {
                        // hier stehen die Objekte (b, g, f, l, p) mit ihren jeweiligen Parametern
                        String objName = st.nextToken("()");
                        
                        // nur weiter machen, wenn die see-Nachricht nicht leer ist
                        if (!objName.equals(" ")) {
                            //System.out.println("objName = " + objName);
                            if(st.hasMoreTokens()){
                                // hier stehen die zum Objekt gehoerenden Parameter (u.a. Entfernung, Winkel)
                                String data = st.nextToken();
                                //System.out.println("data = " + data); //zum Testen
                                
                                // erkenne die gesehenen Objekte aus der see-Nachricht
                                switch(objName.charAt(0)){
                                    
                                    // Ball gesehen, dann konstruiere Object RelativBall
                                    case 'b':
                                        try{
                                            StringTokenizer stBall   = new StringTokenizer(data, " ");
                                            
                                            //wenn nur Richtung bekannt ist bleibt distance auf -1, sonst ueberschreiben
                                            if(stBall.countTokens() != 1)
                                                distance = Float.parseFloat(stBall.nextToken());
                                            
                                            angle = Float.parseFloat(stBall.nextToken());
                                            //DistanceChange und DirectionChange
                                            if(stBall.hasMoreTokens()){
                                                float distCh = Float.parseFloat(stBall.nextToken());
                                                float dirCh = Float.parseFloat(stBall.nextToken());
                                                // System.out.println("distChange: "+distCh);
                                                // System.out.println("dirChange: "+dirCh);
						RelativBall relativBall = new RelativBall( distance, angle, timeStamp, distCh, dirCh );
						objVector.addElement(relativBall);    
                                            }
                                            else {
						// Konstruktor aufrufen und das Erzeugte zum objVektor hinzufgen
						RelativBall relativBall = new RelativBall(distance, angle, timeStamp);
					    objVector.addElement(relativBall); 
					    }
                                            //System.out.println(distance);   //Test
                                            //System.out.println(angle);      //Test
                                            
                                        }//Ende try case 'b'
                                        
                                        catch(Exception e){
                                            System.out.println("Parserfehler beim Ball");
                                        }// Ende catch case 'b'
                                        
                                        break; // case b
                                        
                                        
                                        // Tor gesehen, konstruiere Object RelativTor
                                    case 'g':
                                        try{
                                            StringTokenizer tor = new StringTokenizer(objName, " ");
                                            
                                            if (tor.countTokens() == 2) {
                                                //linkes oder rechtes Tor
                                                char goal = objName.charAt(2);
                                                
                                                StringTokenizer stTor = new StringTokenizer(data, " ");
                                                
                                                //wenn nur Richtung bekannt ist bleibt distance auf -1, sonst ueberschreiben
                                                if(stTor.countTokens() != 1)
                                                    distance = Float.parseFloat(stTor.nextToken());
                                                
                                                angle = Float.parseFloat(stTor.nextToken());
                                                
                                                // Konstruktor aufrufen und das Erzeugte zum objVektor hinzufgen.
                                                // Entweder kann ein Objekt relTor oder aber gleich ein Objekt
                                                // relFahne zur Vereinfachung der Berechnungen erzeugt werden
                                                
                                                //RelativTor relTor = new RelativTor(distance, angle, timeStamp, goal);
                                                //objVector.addElement(relTor);
                                                RelativFahne relFahne = new RelativFahne(distance, angle, timeStamp, goal);
                                                objVector.addElement(relFahne);
                                                
                                                //System.out.println("relTor - Seite: " + goal); // Test
                                                //System.out.println("relTor - distance: " + distance);  // Test
                                                //System.out.println("relTor - timeStamp: " + timeStamp);  // Test
                                                //System.out.println("relTor - angle: " + angle);     // Test
                                                
                                                
                                            } // Ende if(Anzahl Tokens) bei Tor
                                        }// Ende try case 'g'
                                        
                                        catch(Exception e){
                                            System.out.println("Parserfehler beim Tor");
                                        }// Ende catch case 'g'
                                        
                                        break; // case g
                                        
                                        
                                        // Fahne gesehen, konstruiere Object Fahne
                                    case 'f':
                                        
                                        // Instanziere relativeFahne
                                        RelativFahne relFahne;
                                        
                                        StringTokenizer fahne = new StringTokenizer(objName, " ");
                                        
                                        int paramNum = fahne.countTokens();
                                        //System.out.println("Anzahl der Param.: " + paramNum); // Test
                                        
                                        StringTokenizer stFahne   = new StringTokenizer(data, " ");
                                        
                                        // je nach der Anzahl der Parameter wird der dazugehoerige
                                        // Konstruktor fr die Fahne aufgerufen
                                        switch(paramNum) {
                                            
                                            // einziger Fall: Fahne in der Mitte
                                            case 2:
                                                try{
                                                    if(stFahne.countTokens() != 1)
                                                        distance = Float.parseFloat(stFahne.nextToken());
                                                    
                                                    angle = Float.parseFloat(stFahne.nextToken());
                                                    
                                                    //ueberspringe f
                                                    fahne.nextToken();
                                                    
                                                    char pos = fahne.nextToken().charAt(0);
                                                    // Konstruktor aufrufen und das Erzeugte zum objVektor hinzufgen
                                                    relFahne = new RelativFahne(distance, angle, timeStamp, pos);
                                                    objVector.addElement(relFahne);
                                                    
                                                    //System.out.println("pos = " + pos);     //Test
                                                    
                                                }// Ende try case 'f2'
                                                
                                                catch(Exception e){
                                                    System.out.println("Parserfehler bei der Fahne mit 2 Parametern");
                                                }
                                                
                                                break; // case 2
                                                
                                                
                                                // Fahne links | rechts | in der Mitte & oben | unten
                                            case 3:
                                                try{
                                                    if(stFahne.countTokens() != 1)
                                                        distance = Float.parseFloat(stFahne.nextToken());
                                                    
                                                    angle = Float.parseFloat(stFahne.nextToken());
                                                    
                                                    // ueberspringe f
                                                    fahne.nextToken();
                                                    
                                                    // Fahne links, mitte oder rechts
                                                    char lmr = fahne.nextToken().charAt(0);
                                                    //System.out.println("links_mitte_rechts: " + lmr);
                                                    
                                                    // Fahne oben oder unten
                                                    char ou = fahne.nextToken().charAt(0);
                                                    //System.out.println("oben_unten: " + ou);
                                                    
                                                    // Konstruktor aufrufen
                                                    if (ou == '0')
                                                        relFahne = new RelativFahne(distance, angle, timeStamp, lmr, 0);
                                                    else
                                                        relFahne = new RelativFahne(distance, angle, timeStamp, lmr, ou);
                                                    
                                                    // das erzeugte Objekt zum objVektor hinzufgen
                                                    objVector.addElement(relFahne);
                                                    
                                                    //System.out.println("distFahne = " + distance);    //Test
                                                    //System.out.println("distAng = " + angle);     //Test
                                                    
                                                }// Ende try case 'f3'
                                                
                                                catch(Exception e){
                                                    System.out.println("Parserfehler bei der Fahne mit 3 Parametern");
                                                }// Ende catch case 'f3'
                                                
                                                break; // case 3
                                                
                                                
                                                // Fahne im Strafraum | Torraum
                                            case 4:
                                                try{
                                                    if(stFahne.countTokens() != 1)
                                                        distance = Float.parseFloat(stFahne.nextToken());
                                                    
                                                    angle = Float.parseFloat(stFahne.nextToken());
                                                    
                                                    //System.out.println("distFahne = " + distance);    //Test
                                                    //System.out.println("distAng = " + angle);     //Test
                                                    
                                                    // ueberspringe f
                                                    fahne.nextToken();
                                                    
                                                    // Fahne im Strafraum | Torraum
                                                    char pg = fahne.nextToken().charAt(0);
                                                    
                                                    if((pg=='g')| (pg =='p')){
                                                        
                                                        //System.out.println("Fahne Straf- | Torraum: " + pg); //Test
                                                        
                                                        // Fahne links | rechts
                                                        char lr = fahne.nextToken().charAt(0);
                                                        //System.out.println("Fahne rechts_links: " + lr); //Test
                                                        
                                                        // Fahne oben | mitte | unten
                                                        char omu = fahne.nextToken().charAt(0);
                                                        //System.out.println("Fahne oben_mitte_unten: " + omu); //Test
                                                        
                                                        // Konstruktor aufrufen und das Erzeugte zum objVektor hinzufgen
                                                        relFahne = new RelativFahne(distance, angle, timeStamp, pg, lr, omu);
                                                        objVector.addElement(relFahne);
                                                    }
                                                    
                                                    else {
                                                        //Fahne links | rechts | oben | unten
                                                        char lrou = fahne.nextToken().charAt(0);
                                                        
                                                        //wie beim Football yards Angaben
                                                        int yards = Integer.parseInt(fahne.nextToken(" )"));
                                                        
                                                        // Konstruktor aufrufen und das Erzeugte zum objVektor hinzufgen
                                                        relFahne = new RelativFahne(distance, angle, timeStamp, pg, lrou, yards);
                                                        objVector.addElement(relFahne);
                                                    }
                                                    
                                                }// Ende try case 'f4'
                                                
                                                catch(Exception e){
                                                    System.out.println("Parserfehler bei der Fahne mit 4 Parametern");
                                                } // Ende catch case 'f4'
                                                
                                                break; // case 4
                                                
                                                //bei keins der oben genannten Faelle
                                                default:
                                                    break; // case default
                                                    
                                        }  // Ende switch (paranum) - hier sitzt der richtig
                                        
                                        break; // case 'f'
                                        
                                        
                                        //Linie gesehen, konstruiere RelativLinie
                                    case 'l':
                                        try{
                                            StringTokenizer linie = new StringTokenizer(objName, " ");
                                            
                                            if (linie.countTokens() == 2) {
                                                
                                                //Ueberspringe "l"
                                                linie.nextToken();
                                                
                                                //Line Character
                                                char l = linie.nextToken(" )").charAt(0);
                                                
                                                StringTokenizer stLinie   = new StringTokenizer(data, " ");
                                                if(stLinie.hasMoreTokens()){
                                                    if(stLinie.countTokens() != 1) {
                                                        
                                                        distance = Float.parseFloat(stLinie.nextToken());
                                                    }
                                                    //System.out.println("Linie: " + l);
                                                    //System.out.println("distance " + distance);
                                                    
                                                    // String zum Testen, ob das nchste Wort gleicht '-' ist
                                                    String test = stLinie.nextToken();
                                                    
                                                    // wenn ja, tue nichts, ansonsten extrahiere angle usw.
                                                    /*{if(test.equals("-")) {}
                                                    else {*/
                                                    angle = Float.parseFloat(test);
                                                    
                                                    // Konstruktor aufrufen und das Erzeugte zum objVektor hinzufgen
                                                    RelativLinie relLinie = new RelativLinie(distance, angle, timeStamp, l);
                                                    objVector.addElement(relLinie);
                                                    
                                                    //System.out.println("angle: " + angle); // zum Testen
                                                    //}
                                                }
                                            }// Ende if(linie.countTokens)
                                        }// Ende try case 'l'
                                        
                                        catch(Exception e){
                                            System.out.println("\n\nParserfehler bei der Linie: " + " msg: " + msg );
                                            System.out.println("Parserfehler bei der Linie: " + "objName: " + objName + "; data: " + data);
                                        }// Ende catch case 'l'
                                        
                                        break; // case 'l'
                                        
                                        
                                        // Spieler gesehen, konstruiere RelativPlayer
                                    case 'p':
                                        try{
                                            StringTokenizer spieler = new StringTokenizer(objName, " ");
                                            
                                            //Ueberspringe "p"
                                            spieler.nextToken();
                                            
                                            String teamName = "none";
                                            int uniNum = 0;
                                            
                                            if(spieler.hasMoreTokens()){
                                                //extrahiere TeamName
                                                
                                                teamName = spieler.nextToken().replace('"', ' ').trim();
                                                
                                                //System.out.println("TeamName: " + teamName);
                                                if(spieler.hasMoreTokens()){
                                                    
                                                    //extrahiere Spielernummer
                                                    uniNum = Integer.parseInt(spieler.nextToken());
                                                    
                                                    //System.out.println("Nummer: " + uniNum);
                                                    
                                                    if(spieler.hasMoreTokens()){
                                                        spieler.nextToken();
                                                    }
                                                }//Ende if
                                            }
                                            
                                            //System.out.println("Teamname: " + teamName);
                                            //System.out.println("Nummer: " + uniNum);
                                            
                                            StringTokenizer stSpieler = new StringTokenizer(data, " ");
                                            if(stSpieler.hasMoreTokens()){
                                                if(stSpieler.countTokens()!=1)
                                                    
                                                    distance = Float.parseFloat(stSpieler.nextToken());
                                                
                                                // String zum Testen, ob das nchste Wort gleicht '-' ist
                                                String test = stSpieler.nextToken();
                                                
                                                // wenn ja, tue nichts, ansonsten extrahiere angle usw.
                                                /*if(test.equals("-")) {}
                                                else {*/
                                                angle = Float.parseFloat(test);
                                                
                                                //den Rest brauchen wir nicht, sagt Dennis
                                                //float distChange = Float.parseFloat(stSpieler.nextToken());
                                                //float dirChange = Float.parseFloat(stSpieler.nextToken());
                                                //float bodyDir = Float.parseFloat(stSpieler.nextToken());
                                                //float headDir = Float.parseFloat(stSpieler.nextToken());
                                                
                                                // Konstruktor aufrufen und das Erzeugte zum objVektor hinzufgen
                                                RelativSpieler relSpieler = new RelativSpieler(distance, angle, timeStamp, uniNum,
                                                teamName);
                                                objVector.addElement(relSpieler);
                                                //}
                                                
                                            }//ende if(stSpieler.hasMoreTokens())
                                            
                                        }//Ende try case 'p'
                                        
                                        catch(Exception e){
                                            //System.out.println("Parserfehler bei den Spielern: " + e + "| uniNum: " + uniNum + " Teamname: " + teamName);
                                            System.out.println("\n\nParserfehler bei den Spielern: " + "msg: " + msg);
                                            System.out.println("Parserfehler bei den Spielern: " + "objName: " + objName + "; data: " + data);
                                            
                                        }// Ende catch case 'p'
                                        
                                        break; // case 'p'
                                        
                                        
                                        //bei keins der oben genannten see-Objekte
                                        default: // see message
                                            break; // default 'see message'
                                            
                                } // Ende switch(objName)
                            } // Ende if(Nachricht nicht leer)
                        } //Ende if st.hasMoreTokens()
                    } // Ende gross try ('see message')
                    
                    catch (Exception e) {
                        System.out.println("Parserfehler bei der see Nachricht");
                    } // Ende gross catch ('see message')
                    
                    
                } // Ende while (st.hasMoreTokens)
            } // Ende if(s.equals("see")
            
            
            //sense_body Nachricht wird einfach immer in der selben Reihenfolge abgearbeitet
            if(s.equals("sense_body")){
                try{
                    // Nachrichtentyp fuer den Player festlegen
                    msgID = BODYMSG;
                    
                    // timeStamp herausgezogen
                    timeStamp = Integer.parseInt(st.nextToken().trim());
                    //System.out.println("Time =" + timeStamp); // zum Testen
                    
                    //view_mode
                    st.nextToken();
                    
                    // high oder low
                    String hl = st.nextToken();
                    
                    // narrow, normal oder wide
                    String nnw = st.nextToken(" )");
                    
                    //System.out.println("view_mode "+hl+" "+nnw);//zum Testen
                    
                    //Stamina Werte
                    st.nextToken();
                    
                    //Stamina
                    float stam = Float.parseFloat(st.nextToken());
                    
                    
                    //Effort
                    float eff = Float.parseFloat(st.nextToken(" )"));
                    //System.out.println("stamina "+stam+" "+eff);  //zum Testen
                    
                    //Geschwindigkeit (speed)
                    st.nextToken();
                    
                    //AmountOfSpeed
                    float asp = Float.parseFloat(st.nextToken());
                    
                    //DirectionOfSpeed
                    float dsp = Float.parseFloat(st.nextToken(" )"));
                    //System.out.println("speed "+asp+" "+dsp);//zum Testen
                    
                    //Kopfwinkel (head_angle)
                    st.nextToken();
                    float ha = Float.parseFloat(st.nextToken(" )"));
                    //System.out.println("head_angle "+ha);//zum Testen
                    
                    //KickCount
                    st.nextToken();
                    int k = Integer.parseInt(st.nextToken(" )"));
                    //System.out.println("kick "+ k);//zum Testen
                    
                    //DashCount
                    st.nextToken();
                    int d = Integer.parseInt(st.nextToken(" )"));
                    //System.out.println("dash "+ d);//zum Testen
                    
                    //TurnCount
                    st.nextToken();
                    int t = Integer.parseInt(st.nextToken(" )"));
                    //System.out.println("turn "+ t);//zum Testen
                    
                    //SayCount
                    st.nextToken();
                    int sc = Integer.parseInt(st.nextToken(" )"));
                    //System.out.println("say "+ sc);//zum Testen
                    
                    //TurnNeckCount
                    st.nextToken();
                    int tn = Integer.parseInt(st.nextToken(" )"));
                    //System.out.println("turn_neck "+ tn);//zum Testen
                    
                    //CachCount
                    st.nextToken();
                    int ca = Integer.parseInt(st.nextToken(" )"));
                    //System.out.println("catch "+ ca);//zum Testen
                    
                    //MoveCount
                    st.nextToken();
                    int m = Integer.parseInt(st.nextToken(" )"));
                    //System.out.println("move "+ m);//zum Testen
                    
                    //ChangeViewCount
                    st.nextToken();
                    int cv = Integer.parseInt(st.nextToken(" )"));
                    //System.out.println("change_view "+ cv);//zum Testen
                    
                    // Konstruktor fr BodyObject aufrufen
                    bodyObject = new BodyObject(timeStamp, stam, asp, dsp, ha);
                }//ende try
                catch(Exception e){
                    System.out.println("Parserfehler bei sense_body");
                }
            }//Ende sense_body-Nachricht
            
            
            // init-Nachricht
            if(s.equals("init")){
                
                // Nachrichtentyp fuer den Player festlegen
                msgID = INITMSG;
                
                //spielen wir von links nach rechts oder von rechts nach links
                char side = st.nextToken().charAt(0);
                
                //meine Trikotnummer
                int uniNum = Integer.parseInt(st.nextToken());
                
                //System.out.println("Side = " + side + "!");//zum Test
                //boolean left2right, der abgibt ob wir von links nach rechts spielen
                left2right = (side == 'l');
                
                //System.out.println("left2right: " + left2right); ///zum Test
                
            }//Ende init-Nachricht
            
            // hear-Nachricht
            if(s.equals("hear")){
                
                //timeStamp herausziehen
                timeStamp = Integer.parseInt(st.nextToken().trim());
                //System.out.println("hear_timeStamp: " + timeStamp); // Test
                
                // ueberpruefe, von wem die Nachricht kam
                String sender = st.nextToken();
                
                if((sender.equals("referee"))){
                    
                    //System.out.println("hear_sender: " + sender); // Test
                    
                    msgID = REFMSG;
                    
                    //Nachrichten des referee
                    String ref = st.nextToken(" )");
                    
                    //System.out.println("ref:" + ref + "!"); // Test
                    
                    //PlayMode "play_on"
                    if(ref.equals("play_on")) {
                        playModi = Player.PLAY_ON;
                    }
                    else {
                        //PlayMode "kick_in_Side" bei Einwurf
                        if(ref.equals("kick_in_l")){
                            if(left2right)
                                playModi = Player.KICK_IN_MYTEAM;
                            else
                                playModi = Player.KICK_IN_OPP;
                        }
                        
                        else {
                            //PlayMode "kick_in_Side" bei Einwurf
                            if(ref.equals("kick_in_r")){
                                if(left2right)
                                    playModi = Player.KICK_IN_OPP;
                                else
                                    playModi = Player.KICK_IN_MYTEAM;
                            }
                            else {
                                //PlayMode "goal_kick_Side" bei Toraus
                                if(ref.equals("goal_kick_l")){
                                    if(left2right)
                                        playModi = Player.GOAL_KICK_MYTEAM;
                                    else
                                        playModi = Player.GOAL_KICK_OPP;
                                }
                                
                                else {
                                    //PlayMode "goal_kick_Side" bei Toraus
                                    if(ref.equals("goal_kick_r")){
                                        if(left2right)
                                            playModi = Player.GOAL_KICK_OPP;
                                        else
                                            playModi = Player.GOAL_KICK_MYTEAM;
                                    }
                                    
                                    else {
                                        //PlayMode "corner_kick_Side" bei Ecksto
                                        if(ref.equals("corner_kick_l")){
                                            if(left2right)
                                                playModi = Player.CORNER_KICK_MYTEAM;
                                            else
                                                playModi = Player.CORNER_KICK_OPP;
                                        }
                                        
                                        else {
                                            //PlayMode "corner_kick_Side" bei Ecksto
                                            if(ref.equals("corner_kick_r")){
                                                if(left2right)
                                                    playModi = Player.CORNER_KICK_OPP;
                                                else
                                                    playModi = Player.CORNER_KICK_MYTEAM;
                                            }
                                            
                                            else {
                                                //bei Strings vom referee ergeben sich auch playModes
                                                //pruefe, ob der String = goal_[l|r]_n , wobei n eine Zahl ist
                                                
                                                if(ref.substring(0,ref.indexOf("_")).equals("goal")){
                                                    playModi = Player.BEFORE_KICK_OFF;
                                                    //Anzahl der Tore bestimmen
                                                    //myScore = Integer.parseInt(ref.substring(7));
                                                }
                                                
                                                else {
                                                    //PlayMode "before_kick_off" for jede Haelfte
                                                    if(ref.equals("before_kick_off")){
                                                        playModi = Player.BEFORE_KICK_OFF;
                                                    }
                                                    
                                                    else {
                                                        //PlayMode "kick_off_Side" vor Spielbeginn
                                                        if(ref.equals("kick_off_l")){
                                                            if(left2right)
                                                                playModi = Player.KICK_OFF_MYTEAM;
                                                            else
                                                                playModi = Player.KICK_IN_OPP;
                                                        }
                                                        
                                                        else {
                                                            //PlayMode "kick_off_Side" vor Spielbeginn
                                                            if(ref.equals("kick_off_r")){
                                                                if(left2right)
                                                                    playModi = Player.KICK_OFF_OPP;
                                                                else
                                                                    playModi = Player.KICK_OFF_MYTEAM;
                                                            }
                                                            
                                                            else {
                                                                //PlayMode "kick_off_Side" bei einem Freisto
                                                                if(ref.equals("free_kick_l")){
                                                                    if(left2right)
                                                                        playModi = Player.FREE_KICK_MYTEAM;
                                                                    else
                                                                        playModi = Player.FREE_KICK_OPP;
                                                                }
                                                                
                                                                else {
                                                                    //PlayMode "kick_off_Side" bei einem Freisto
                                                                    if(ref.equals("free_kick_r")){
                                                                        if(left2right)
                                                                            playModi = Player.FREE_KICK_OPP;
                                                                        else
                                                                            playModi = Player.FREE_KICK_MYTEAM;
                                                                    }
                                                                    
                                                                    else {
                                                                        //Halbzeit
                                                                        if(ref.equals("half_time")){
                                                                            playModi = Player.BEFORE_KICK_OFF;
                                                                        }
                                                                        
                                                                        else {
                                                                            //PlayMode "time_over" beim Ende des Spiels/Haelfte
                                                                            if(ref.equals("time_over")){
                                                                                playModi = Player.TIME_OVER;
                                                                            }
                                                                            
                                                                            else {
                                                                                //Freisto nach einem Faul
                                                                                if(ref.equals("foul_l")){
                                                                                    if(left2right)
                                                                                        playModi = Player.FREE_KICK_MYTEAM;
                                                                                    else
                                                                                        playModi = Player.FREE_KICK_OPP;
                                                                                }
                                                                                
                                                                                else {
                                                                                    //Freisto nach einem Faul
                                                                                    if(ref.equals("foul_r")){
                                                                                        if(left2right)
                                                                                            playModi = Player.FREE_KICK_MYTEAM;
                                                                                        else
                                                                                            playModi = Player.FREE_KICK_OPP;
                                                                                    }
                                                                                    
                                                                                    else {
                                                                                        //Freisto fuer A nach dem Torwart von B den von B zugespielten Ball gefangen hat
                                                                                        if(ref.equals("goalie_catch_ball_l")){
                                                                                            if(left2right)
                                                                                                playModi = Player.FREE_KICK_OPP;
                                                                                            else
                                                                                                playModi = Player.FREE_KICK_MYTEAM;
                                                                                        }
                                                                                        
                                                                                        else {
                                                                                            //Freisto fuer A nach dem Torwart von B den von B zugespielten Ball gefangen hat
                                                                                            if(ref.equals("goalie_catch_ball_r")){
                                                                                                if(left2right)
                                                                                                    playModi = Player.FREE_KICK_MYTEAM;
                                                                                                else
                                                                                                    playModi = Player.FREE_KICK_OPP;
                                                                                            }
                                                                                            
                                                                                            else {
                                                                                                //time_up bedeutet Zeitabgelaufen, d.h Spiel vorbei
                                                                                                if(ref.equals("time_up")){
                                                                                                    playModi = Player.TIME_OVER;
                                                                                                }
                                                                                                
                                                                                                else {
                                                                                                    //es gibt Verlaengerung
                                                                                                    if(ref.equals("time_extended")){
                                                                                                        playModi = Player.BEFORE_KICK_OFF;
                                                                                                    }
                                                                                                    
                                                                                                    else {
                                                                                                        //wenn Gegner nicht antreten, ist das Spiel auch vorbei
                                                                                                        if(ref.equals("time_up_without_a_team")){
                                                                                                            playModi = Player.TIME_OVER;
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    
                    // System.out.println("PlayModi: " + playModi); // Test
                    
                }// Ende if(sender == referee)
                
                else {
                    
                    // Nachrichtentyp fuer den Player festlegen
                    msgID = HEARMSG;
                    
                    // wenn Nachricht vom Coach, Referee oder mir selbst
                    if ((sender.equals("online_coach_left")) |
                    (sender.equals("online_coach_right"))    |
                    (sender.equals("self"))) {
                        
                        // System.out.println("Sender: " + sender); // zur spterer Auswertung
                    }
                    
                    // sonst ist nur die Richtung bekannt
                    else {
                        // Richtung des Nachrichtensenders
                        float direction = Float.parseFloat(sender);
                        // System.out.println("hear_direction: " + direction); // Test
                    }
                    
                    // Nachricht selbst, abgespeichert in 'message'
                    String message = st.nextToken(" )");
                    // System.out.println("hear_message: " + message); // Test
                    
                } // Ende nichtReferee
            } // Ende hear
            
            
            // error-Nachricht
            if(s.equals("error")){
                
                // Nachrichtentyp fuer den Player festlegen
                msgID = ERRMSG;
                
                // System.out.println("Server: Nachricht nicht verstanden: " + st.nextToken());
            }//Ende error-Nachricht
            
        } // Ende try parseMsg
        
        catch(Exception e){
            System.err.println("globaler Parserfehler");
        }// Ende catch parseMsg
        
        // Rueckgabewert (Nachrichtentyp)
        // System.out.println("msgID: " + msgID);
        return msgID;
        
    } // Ende parseMsg
    
    
    /**
     * returns the class Vector with RelativFieldObjects
     */
    public Vector getRelativObjects() {
        return objVector;
    }
    
    /**
     * returns the class BodyObject
     */
    public BodyObject getBodyObject() {
        return bodyObject;
    }
    
    /**
     * returns the simulation cycle of the recent message
     */
    public int getTimeStamp() {
        return timeStamp;
    }
    
    /**
     * returns true if we play from left to right
     */
    public boolean getLeft2right() {
        return left2right;
    }
    
    /**
     * returns the current playmode
     */
    public int getPlayModi() {
        return playModi;
    }
    
    
    //zum Testen eine Mainklasse
    /*public static void main(String args[]){
        //String ms = "(hear 14 referee time_up_without_a_team)";
        //String ms = "(init l 5 before_kick_off)";
        //String ms = "(see 45 ((p) -50.4 -20))";
        //String ms = "(see 45 ((p \"TeamMoni\" 2) -50.4 -20))";
        String ms = "(see 41 )";
        //String ms = "(see 45 ((g r) 5 4 87 54 1 5))";
        //String ms = "(see 45 ((b) 54 85))";
        //String ms = "(see 52 ((f c) 46.5 -15) ((f c b) 49.9 26) ((f r t) 107.2 -15) ((g r) 98.5 -7) ((p) 52 -10) ((l r) 98 -90))";
        //String ms = "(see 15 ((f l 0) -25) ((f) 50.4 20) ((f c t) -50.4 20) ((f p l t) 50.4 -20) ((l t) -25 -12))";
        //String ms = "(see 2 ((p \"Team\" 5) 52 3 8 5 25.2 63.5 ))";
        //String ms = "(sense_body 15 (view_mode high normal) (stamina 4000 1) (speed 0 0) (head_angle 0) (kick 0) (dash 0) (turn 0) (say 0) (turn_neck 0) (catch 0) (move 0) (change_view 0)";
        int in = parseMsg(ms);
    }*/
    
} // Ende Parser
