package bitsUnited;

/*
 $Id: RelativBall.java,v 1.12 2002/07/07 17:30:27 mj Exp $
 $Log: RelativBall.java,v $
 Revision 1.12  2002/07/07 17:30:27  mj
 f1

 Revision 1.10  2002/07/07 11:28:28  dd
 fuer den Ball distChange und dirchange eingebaut. in AbsolutBall zusaetzliche Positionsveraenderung
 verfuegbar ueber getPosCh_X() bzw. getPosCh_y()
 CV : ----------------------------------------------------------------------

 Revision 1.8  2002/07/07 10:05:46  dd
 *** empty log message ***

 Revision 1.7  2002/07/06 12:30:26  mj
 Rationalisierung

 Revision 1.6  2002/07/02 23:47:27  ju
 package von robocop in bitsUnited umbenannt; mehr nicht...

 Revision 1.5  2002/06/26 14:26:47  mj
 keine Ahnung warum CVS eine Aenderung feststellt

 Revision 1.4  2002/06/23 21:40:27  mj
 inzwischen unnoetig gewordenes wegrationalisiert

 Revision 1.3  2002/06/18 14:51:28  mj
 no message

 Revision 1.2  2002/06/09 12:21:52  dd
 Fahnenumrechnung in RelativFahne eingebaut
 
 Revision 1.1  2002/05/29 18:28:34  dd
 Erste Version
 
 */

/**
 * A relativ representation of the Ball. Is derived from
 * RelativFieldObject.
 * @see RelativFieldObject
 */
public class RelativBall extends RelativFieldObject {

    private float distchange;   // Distance-Change
    private float dirchange;    // Direction-Change

    /**
     * Initializes a new RelativBall object with
     * @param distance the distance of the ball relativ to the players view
     * @param angle the angle relativ to the players view
     * @param timestamp the timestamp when the information was recieved

     */
    RelativBall(float distance, float angle, int timeStamp ) {
        super(distance,angle,timeStamp);

    }

    /**
     * Initializes a new RelativBall object with
     * @param distance the distance of the ball relativ to the players view
     * @param angle the angle relativ to the players view
     * @param timestamp the timestamp when the information was recieved
     * @param distch the value distance_change
     * @param dirch the value direction_change
     */
    RelativBall(float distance, float angle, int timeStamp, float distch, float dirch ) {
        super(distance,angle,timeStamp);
	this.distchange = distch;
	this.dirchange  = dirch;
    }

    /**
     * Returns the type of RelativFieldObject - is used for casting the Objects
     */
    public int getType() {
        return BALL;
    }
    
    /**
     * Returns the value of distance_change
     */
    public float getDistChange(){
	return distchange;
    }

    /**
     * Returns the value of direction_change
     */
    public float getDirChange() {
	return dirchange;
    }
    
}
