package bitsUnited;

/*
 $Id: RelativFahne.java,v 1.9 2002/07/02 23:47:27 ju Exp $
 $Log: RelativFahne.java,v $
 Revision 1.9  2002/07/02 23:47:27  ju
 package von robocop in bitsUnited umbenannt; mehr nicht...

 Revision 1.8  2002/06/30 15:18:21  dd
 Weltmodell jetzt auch von Rechts nach Links, Positionsbestimmung genauer

 Revision 1.7  2002/06/25 16:54:12  as
 Ein Konstruktor ergnzt: die Toren werden jetzt (zur genauen Positionsbestimmung) als Fahnen abgelgt.

 Revision 1.6  2002/06/25 08:21:12  dd
 Fahnen, Weltmodell und Visualisierung gecheckt
 
 Revision 1.5  2002/06/20 22:52:28  dd
 Weltmodell funktioniert, Parser gefixt, Client lauffhig
 
 Revision 1.4  2002/06/18 14:51:28  mj
 no message
 
 Revision 1.3  2002/06/09 12:21:52  dd
 Fahnenumrechnung in RelativFahne eingebaut
 
 Revision 1.2  2002/05/31 18:20:09  dd
 Weltmodell implementiert und RelativFieldObjects angepasst.
 */

/**
 * Relativ representation of a flag in the visual range of the player.
 * By calling the appropriate constructor the absolute position of
 * the flag is determined and stored.
 * @see RelativFieldObject
 */
public class RelativFahne extends RelativFieldObject {
    
    
    // Absolute Position der Fahne - wird ermittelt aus der "FahnenID"
    private float x;
    private float y;
    
    /**
     *  Constructor for RelativFahne
     *  @param distance from the players view
     *  @param angle under which the player sees the flag
     *  @param timestamp of the event
     *  @param pos1 first position-character
     *  @param pos2 second position-character
     *  @param pos3 third position-character
     */
    public RelativFahne( float distance, float angle, int timestamp,
    char pos1, char pos2, char pos3) {
        super( distance, angle, timestamp );
        switch (pos1) {
            case 'p':
                switch (pos2) {
                    case 'l':
                        x= -36.5f;
                        break;
                    case 'r':
                        x= 36.5f;
                        break;
                    default:
                        x= -100;
                        break;
                }
                switch (pos3) {
                    case 't':
                        y= -20;
                        break;
                    case 'c':
                        y= 0;
                        break;
                    case 'b':
                        y= 20;
                        break;
                    default:
                        y = -100;
                        break;
                }
                break;
            case 'g':
                switch (pos2) {
                    case 'l':
                        x= -52.5f;
                        break;
                    case 'r':
                        x= 52.5f;
                        break;
                    default:
                        x= -100;
                        break;
                }
                switch (pos3) {
                    case 't':
                        y= -7;
                        break;
                    case 'b':
                        y= 7;
                        break;
                    default:
                        y= -100;
                        break;
                }
        }
    }
    
    /**
     *  Constructor for RelativFahne
     *  @param distance from the players view
     *  @param angle under which the player sees the flag
     *  @param timestamp of the event
     *  @param pos1 first position-character
     *  @param pos2 second position-character
     *  @param posnum number of the flag
     */
    public RelativFahne( float distance, float angle, int timestamp,
    char pos1, char pos2, int posnum) {
        super( distance, angle, timestamp );
        
        switch (pos1) {
            case 't':
                y= -39;
                break;
            case 'b':
                y= 39;
                break;
            case 'l':
                x= -57.5f;
                break;
            case 'r':
                x = 57.5f;
                break;
            default:
                x= -100;
                break;
        }
        switch (pos2) {
            case 'l':
                x= -1 * posnum;
                break;
            case 'r':
                x = posnum;
                break;
            case 't':
                y = -1 * posnum;
                break;
            case 'b':
                y = posnum;
                break;
            default:
                y = -100;
                break;
        }
    }
    
    /**
     *  Constructor for RelativFahne
     *  @param distance from the players view
     *  @param angle under which the player sees the flag
     *  @param timestamp of the event
     *  @param pos1 first position-character
     *  @param posnum number of the flag
     */
    public RelativFahne( float distance, float angle, int timestamp,
    char pos1, int posnum ) {
        super( distance, angle, timestamp );
        
        switch (pos1) {
            case 't':
                y = -39;
                x = posnum;
                break;
            case 'b':
                y = 39;
                x = posnum;
                break;
            case 'r':
                x = 57.5f;
                y = posnum;
                break;
            case 'l':
                x = -57.5f;
                y = posnum;
                break;
            default:
                x = -100;
                y = -100;
                break;
        }
    }
    
    /**
     *  Constructor for RelativFahne
     *  @param distance from the players view
     *  @param angle under which the player sees the flag
     *  @param timestamp of the event
     *  @param pos1 first position-character
     *  @param pos2 second position-character
     */
    public RelativFahne( float distance, float angle, int timestamp,
    char pos1, char pos2) {
        super( distance, angle, timestamp );
        switch (pos1) {
            case 'c':
                x = 0;
                break;
            case 'r':
                x = 52.5f;
                break;
            case 'l':
                x = -52.5f;
                break;
            default:
                x = -100;
                break;
        }
        switch (pos2) {
            case 't':
                y = -34;
                break;
            case 'b':
                y = 34;
                break;
            default:
                y = -100;
                break;
        }
    }
    
    /**
     *  Constructor for RelativFahne
     *  @param distance from the players view
     *  @param angle under which the player sees the flag
     *  @param timestamp of the event
     *  @param pos position-character
     */
    public RelativFahne( float distance, float angle, int timestamp,
    char pos) {
        super( distance, angle, timestamp);
        
        switch (pos) {
            
            // Fahne im Spielfeldmittelpunkt
            case 'c':
                x = 0;
                y = 0;
                break;
                
                // das rechte Tor
            case 'r':
                x = 52.5f;
                y = 0;
                break;
                
                // das linke Tor
            case 'l':
                x = -52.5f;
                y = 0;
                break;
                
                // Fahne unbekannt
            default:
                x = -100;
                y = -100;
                break;
        }
    }
    
    /**
     * Returns the type of RelativFieldObject - is used for casting the Objects
     */
    public int getType() {
        return FAHNE;
    }
    
    /**
     * Returns the X value of the flags absolut position
     * @param left2right true if we play from left to right
     */
    public float getX(boolean left2right) {
        return (left2right)?x:-x;
    }
    
    /**
     * Returns the Y value of the flags absolut position
     * @param left2right true if we play from left to right
     */
    public float getY(boolean left2right) {
        return (left2right)?y:-y;
    }
    
}











