package bitsUnited;

/*
 $Id: RelativFieldObject.java,v 1.11 2002/07/07 17:22:10 mj Exp $
 $Log: RelativFieldObject.java,v $
 Revision 1.11  2002/07/07 17:22:10  mj
 javadoc-update

 Revision 1.9  2002/07/06 12:30:33  mj
 Rationalisierung

 Revision 1.8  2002/07/05 15:13:34  ts
 ..bug-fixing und dokumentation

 Revision 1.7  2002/07/02 23:47:27  ju
 package von robocop in bitsUnited umbenannt; mehr nicht...

 Revision 1.6  2002/06/18 14:51:28  mj
 no message

 Revision 1.4  2002/06/09 23:39:12  as
 no message

 Revision 1.2  2002/05/31 18:20:09  dd
 Weltmodell implementiert und RelativFieldObjects angepasst.

 Revision 1.1  2002/05/29 18:28:34  dd
 Erste Version

 */

/**
 *
 *  The class RelativFieldObject generates an object of
 *	the messages coming from the server for further usage
 *
 */
public class RelativFieldObject {

/** constant integer representing the object type "abstract"
 */
    public static final int ABSTRACT = 0;

/** constant integer representing the object type "goal"
 */
    public static final int TOR = 1;

/** constant integer representing the object type "line"
 */
    public static final int LINIE = 2;

/** constant integer representing the object type "flag"
 */
    public static final int FAHNE = 3;

/** constant integer representing the object type "ball"
 */
    public static final int BALL = 5;

/** constant integer representing the object type "sports player"
 */
    public static final int SPIELER = 6;



    private float distance;
    private float angle;
    private int timeStamp;

    
    /**Constructor for RelativeFieldObject
     *
     *...puts the separate values into one object
     *  @param distance from the players view
     *  @param angle under which the player sees the flag
     *  @param timestamp of the event
     */
    public RelativFieldObject (float distance, float angle, int timeStamp) {
        this.distance = distance;
        this.angle = angle;
        this.timeStamp = timeStamp;
    }


    /** looks for the current distanc value (from player to e.g. flag)
     */
    public float getDistance () {
        return distance;
    }


    /** looks for the current angle from e.g. the flag
     */
    public float getAngle () {
        return angle;
    }


    /** looks for the current timestamp from e.g. the flag
     */
    public int getTimeStamp () {
        return timeStamp;
    }


    /** looks for the current type of the seen thing e.g. flag, line, ...
     */
    public int getType() {
        return ABSTRACT;
    }
}







