package bitsUnited;

/*
 $Id: RelativLinie.java,v 1.7 2002/07/07 17:22:10 mj Exp $
 $Log: RelativLinie.java,v $
 Revision 1.7  2002/07/07 17:22:10  mj
 javadoc-update

 Revision 1.5  2002/07/06 12:30:40  mj
 Rationalisierung

 Revision 1.4  2002/07/02 23:47:27  ju
 package von robocop in bitsUnited umbenannt; mehr nicht...

 Revision 1.3  2002/06/18 14:51:28  mj
 no message

 Revision 1.2  2002/06/09 12:21:52  dd
 Fahnenumrechnung in RelativFahne eingebaut
 
 Revision 1.1  2002/05/29 18:28:34  dd
 Erste Version
 
 */

/**
 * A relative representation of a line. Is derived from
 * RelativFieldObject.
 * @see RelativFieldObject
 */
public class RelativLinie extends RelativFieldObject {
    
    private char linechar;
    
    /**
     * Initializes a new RelativLinie object with
     * @param distance the distance of the line relative to the players view
     * @param angle the smaller angle between the line and the players view
     * @param timestamp the timestamp when the information was recieved
     */
    public RelativLinie( float distance, float angle, int timestamp,
    char linechar) {
        super( distance, angle, timestamp);
        this.linechar = linechar;
    }
    
    /**
     * Returns the type of RelativFieldObject - is used for casting the Objects
     */
    public int getType() {
        return LINIE;
    }
    
    /**
     * Returns the character which identifies the line as it was recieved
     * by the Server
     */
    public int getLineChar() {
        return linechar;
    }
}


