package bitsUnited;

/*
 $Id: RelativSpieler.java,v 1.9 2002/07/07 17:22:10 mj Exp $
 $Log: RelativSpieler.java,v $
 Revision 1.9  2002/07/07 17:22:10  mj
 javadoc-update

 Revision 1.8  2002/07/05 15:13:34  ts
 ..bug-fixing und dokumentation

 Revision 1.7  2002/07/02 23:47:27  ju
 package von robocop in bitsUnited umbenannt; mehr nicht...

 Revision 1.6  2002/06/23 21:40:18  mj
 inzwischen unnoetig gewordenes wegrationalisiert

 Revision 1.5  2002/06/18 14:51:28  mj
 no message

 Revision 1.3  2002/06/09 12:21:52  dd
 Fahnenumrechnung in RelativFahne eingebaut

 Revision 1.2  2002/05/31 18:20:09  dd
 Weltmodell implementiert und RelativFieldObjects angepasst.

 Revision 1.1  2002/05/29 18:28:34  dd
 Erste Version

 */


/**
 * A relative representation of a soccer viewed by one of ours. Is derived from
 * <code>RelativFieldObject</code>.
 * @see RelativFieldObject
 */
public class RelativSpieler extends RelativFieldObject {

    private int spielernum;
    private String teamName;

    /**
     * Initializes a new RelativSpieler object with
     * @param distance the distance of the ball relative to the players view
     * @param angle the angle relative to the players view
     * @param timestamp the timestamp when the information was recieved
     * @param spielernum the players number
     * @param teamName his teamname
     */
    public RelativSpieler( float distance, float angle, int timestamp,
    int spielernum, String teamName) {
        super( distance, angle, timestamp );
        this.spielernum = spielernum;
        this.teamName = teamName;

    }

    /**
     * Returns the type of RelativFieldObject - is used for casting the Objects
     */
    public int getType() {
        return SPIELER;
    }

    /**
     * Returns the players number
     */
    public int getSpielerNum() {
        return spielernum;
    }

    /**
     * Returns the Players teamname
     */
    public String getTeamName() {
        return teamName;
    }

}


