package bitsUnited;

/*
        $Id: RoboslavKlose.java,v 1.28 2002/07/07 23:09:15 mj Exp $
        $Log: RoboslavKlose.java,v $
        Revision 1.28  2002/07/07 23:09:15  mj
        ...final version... may the force be with u...

        Revision 1.27  2002/07/07 21:32:06  dd
        vorlufiger Endstand

        Revision 1.25  2002/07/07 19:29:07  mj
        ...ballnextpos...

        Revision 1.24  2002/07/07 17:08:26  mj
        *** ueberarbeitet ***

        Revision 1.21  2002/07/06 22:27:47  ju
        ...aenderugnen bzgl. dash, kick und modi...
 
        Revision 1.20  2002/07/04 23:11:28  ju
        genauere playmodi-beachtung (wg stamina),
        flanke statt torschuss bei zu engem winkel,
        warten beim anstoss
 
        Revision 1.19  2002/07/04 22:15:28  ju
        NullPointerException bei Positionsbestimmung wird ge"catch"t
 
        Revision 1.17  2002/07/03 20:28:29  ju
        ...Spieler laufen nur noch max einen halben Meter hinter die Spielfeldmakierung und somit (hoffentlich) nicht mehr aus dem Bildschirm...
 
        Revision 1.16  2002/07/03 19:32:17  ju
        (noch) keine Aktivitaeten bei BEFORE_KICK_OFF
 
        Revision 1.15  2002/07/03 10:55:00  ju
        weiter ueberarbeitet, insb. headAngle-beachtung und playmodi
 
        Revision 1.14  2002/07/02 23:47:27  ju
        package von robocop in bitsUnited umbenannt; mehr nicht...
 
        Revision 1.13  2002/07/02 18:17:54  ju
        ...oldpos entfernt...
 
        Revision 1.5  2002/07/02 11:02:33  ju
        no message
 
 */

import java.util.*;

/**
 * The <code>RoboslavKlose</code> class describes the behavior of a forward player, connected with strategy
 * <code>RoboslavKlose</code>.
 *
 * @author <a href="mailto:mail@jojo4ever.de">Johannes Uihlein</a>
 * @version 0.1
 */
public class RoboslavKlose extends Strategy {
    
    /** this method calls the player actions in dependancy of the playing circumstances */
    public void makeDecision() {
        
        /** the position of the player */
        Position myPos = new Position();
        
        /** the start position of the player */
        Position myStartPos = new Position();
        
        /** the position of the ball */
        Position ballPos = new Position();
        
        float lastX = 0;
        
        float poskorr = 0;
        
        /** the distance from the actual player to the center of the opponent goal */
        float oppGoalDistC = -1;
        
        /** the direction of the actual player to the opponent goal */
        float oppGoalDirC = 0;
        
        /** the direction of the actual player to the opponent goal */
        float oppGoalDirOpt = 0;
        
        /** the distance from the actual player to the ball */
        float ballDist = -1;
        
        /** the direction of the actual player to the ball */
        float ballDir = 0;
        
  /** the direction of the calculated next position of a chosen player */
        float playerNextDir = 0;
        
        /** the distance from a chosen player to the opponent goal */
        float playerGoalDist = -1;
        
        /** the direction from a chosen player to the ball */
        float playerBallDist = -1;
        
        /** the direction from a chosen player to me */
        float playerDistToMe = -1;
        
        /** the direction from a chosen player to a chosen nearest player */
        float playerDistToNearest = -1;
        
        /** the direction of an available teammate */
        float availTmDir = 0;
        
        /** the direction of an available teammate */
        float availTmDist = -1;
        
  /** the distance of the closest teammate to the opponent goal */
        float closestTmDistToGoal = 100;
        
  /** the distance between the teammate, that is closest to the opponent goal, and me */
        float closestTmToGoalDistToMe = 100;
        
  /** the direction of the closest teammate to the opponent goal */
        float closestTmDirToGoal = 0;
        
  /** the distance of the closest teammate to me */
        float closestTmDistToMe = 100;
        
  /** the direction of the closest teammate to me */
        float closestTmDirToMe = 0;
        
        boolean playerVisible = false;
        
        /** true, if the actual player knows the position of the ball */
        boolean foundBall = false;
        
        /** true, if the ball is in a kickable range from the actual player */
        boolean ballInRange = false;
        
        /** true, if the opponent goal is in a shootable range
         * the shootable range is firstly set to 20 meters */
        boolean oppGoalNear = false;
        
        /** true, if the actual player is the closest of his team to the opponent goal */
        boolean amNearestTmToOppGoal = true;
        
        /** true, if the actual player is the closest of his team to the ball */
        boolean amNearestTmToBall = true;
        
        /** true, if a close teammate is available */
        boolean closerTmAvail = false;
        
        /** direction, where should be no opponent player */
        float freeDir = 0;
        
  /** true if minimum one opponent player is in my near */
        boolean oppNear = false;
        
  /** direction of a near opponent player */
        float oppDir;
        
  /** direction to start position */
        float startPosDir = 0;
        
        /** distance from start position */
        float startPosDist = -1;
        
        float lastTmX = 0;
        
        // wo ist das gegnerische Tor frei?
        /**
         * divided the opponent goal in seven parts of a length of 2m and created
         * the following boolean variables for each of those parts.
         * the boolean variables describe, whether the related part of the opponent goal
         * is covered by an opponent player, or not.
         */
        boolean lll_free = true;
        boolean ll_free = true;
        boolean l_free = true;
        boolean c_free = true;
        boolean r_free = true;
        boolean rr_free = true;
        boolean rrr_free = true;
        
        try {
            myPos.setX(myPlayer.getMyPos().getX());
            myPos.setY(myPlayer.getMyPos().getY());
        }
        catch (NullPointerException e) {
            myPlayer.turnBody(110);
            myPlayer.turnHead(-myPlayer.getHeadAngle());
            myPlayer.setPlayStatus(myPlayer.EXCEPTION);
        }
        
        myStartPos.setX(myPlayer.getMyStartPos().getX());
        myStartPos.setY(myPlayer.getMyStartPos().getY());
        
        if ( myPos.getY() > 20) {
            freeDir = -15;
        }
        if ( myPos.getY() < -20 ) {
            freeDir = 15;
        }
        
        float MPDir = dir(0, 0, myPos.getX(), myPos.getY());
        
        switch (myPlayer.getPlayStatus()) {
            
            case Player.EXCEPTION:
            {
                break;
            }
            
            case Player.BEFORE_KICK_OFF:
            {
                if ( myPos.getX()<=(myStartPos.getX()+0.5f) && myPos.getX()>=(myStartPos.getX()-0.5f) &&
                myPos.getY()<=(myStartPos.getY()+0.5f) && myPos.getY()>=(myStartPos.getY()-0.5f)) {
                    
                    if ((myPlayer.getBodyAngle()-MPDir>2) || (myPlayer.getBodyAngle()-MPDir<(-2))) {
                        turnBodyTo(MPDir); if (myPlayer.getReceivedSeeHead()) myPlayer.turnHead(-myPlayer.getHeadAngle());
                    }
                }
                else {
                    myPlayer.move( (int)myStartPos.getX(), (int)myStartPos.getY() );
                }
                break;
            }
            
            case Player.KICK_OFF_OPP:
            {
                if ((myPlayer.getBodyAngle()-MPDir>2) || (myPlayer.getBodyAngle()-MPDir<(-2))) {
                    turnBodyTo(MPDir); if (myPlayer.getReceivedSeeHead()) myPlayer.turnHead(-myPlayer.getHeadAngle());
                }
                break;
            }
            
            default: // also auch CORNER_KICK,...
            {
                
                // Entfernung des Spieler zu seiner Start-Position wird berechnet (Pythagoras)
                startPosDist = dist(myStartPos.getX(), myStartPos.getY(), myPlayer.getMyPos().getX(), myPlayer.getMyPos().getY());
                
                // die Richtung des Balles vom Spieler wird errechnet (tan x = y => x = atan y)
                // Wertebereich: [-180; 180]
                startPosDir =  dir(myStartPos.getX(), myStartPos.getY(), myPlayer.getMyPos().getX(), myPlayer.getMyPos().getY());
                
                // Entfernung zur Tormitte des gegn. Tores vom Spieler
                oppGoalDistC = dist(myPos.getX(), myPos.getY(), 52.5f, 0);
                
                // ist das gegn. Tor in der Naehe?
                if ( oppGoalDistC < 35 ) { oppGoalNear = true; }
                else { oppGoalNear = false; }
                
                // Richtung zur Tormitte des gegn. Tores vom Spieler
                // Wertebereich: [-90; 90]
                oppGoalDirC = dir(52.5f, 0, myPos.getX(), myPos.getY());
                
                oppGoalDirOpt = oppGoalDirC;
                
                for (Enumeration aenum = myPlayer.getWeltmodell().getKnownObjects().elements() ; aenum.hasMoreElements() ;) {
                    AbsolutFieldObject atemp = (AbsolutFieldObject) aenum.nextElement();
                    
                    switch (atemp.getType()) {
                        case AbsolutFieldObject.BALL: {
                            // Ball ist im Weltmodell
                            foundBall = true;
                            
                            // Position des Balles wird gespeichert
                            ballPos.setX(atemp.getX());
                            ballPos.setY(atemp.getY());
                            
                            // Entfernung des Balles zum Spieler wird berechnet (Pythagoras)
                            ballDist = dist(ballPos.getX(), ballPos.getY(), myPos.getX(), myPos.getY());
                            
                            // ist Ball in Reichweite
                            if ( ballDist < 0.85f ) { ballInRange = true; }
                            else { ballInRange = false; }
                            
                            // die Richtung des Balles vom Spieler wird errechnet (tan x = y => x = atan y)
                            // Wertebereich: [-180; 180]
                            ballDir = dir(ballPos.getX(), ballPos.getY(), myPos.getX(), myPos.getY());
                            
                            break;
                        }
                        
                        case AbsolutFieldObject.SPIELER:
                        {
                            playerVisible = true;
                            
                            AbsolutSpieler aspieler = (AbsolutSpieler) atemp;
                            
                            if (aspieler.getX() > lastX) lastX = aspieler.getX();
                            
                            // Entfernung des gefundenen Spieler zum gegn. Tor wird berechnet (Pythagoras)
                            playerGoalDist = dist(52.5f, 0, aspieler.getX(), aspieler.getY());
                            
                            // Entfernung des gefundenen Spieler zu mir wird berechnet (Pythagoras)
                            playerDistToMe = dist(myPos.getX(), myPos.getY(), aspieler.getX(),  aspieler.getY());
                            
                            if (foundBall) {
                                // Entfernung des gefundenen Spieler zum Ball wird berechnet (Pythagoras)
                                playerBallDist = dist(aspieler.getX(), aspieler.getY(), ballPos.getX(), ballPos.getY());
                            }
                            
                            // ist ein Mitspieler??
                            if ( myPlayer.getMyTeamName().equals(aspieler.getTeamName()) ) {
                                
                                if ( foundBall ) {
                                    // naeher am Ball??
                                    if ( amNearestTmToBall ) {
                                        if ( playerBallDist<(ballDist-5) ) { amNearestTmToBall = false; }
                                    }
                                }
                                
                                // in meiner Naehe ??
                                if ( playerDistToMe < closestTmDistToMe ) {
                                    closestTmDistToMe = playerDistToMe;
                                    // Richtung des naeheren Mitspielers wird errechnet (tan x = y => x = atan y)
                                    // Wertebereich: [-180; 180]
                                    closestTmDirToMe = dir(aspieler.getX(), aspieler.getY(), myPos.getX(), myPos.getY());
                                }
                                
                                // naeher am gegn. Tor??
                                if ( playerGoalDist < oppGoalDistC ) {
                                    
                                    if (amNearestTmToOppGoal) { amNearestTmToOppGoal = false; }
                                    
                                    // naeher als andere Mitspieler zuvor??
                                    if ( playerGoalDist < closestTmDistToGoal ) {
                                        closestTmToGoalDistToMe = playerDistToMe;
                                        closestTmDistToGoal = playerGoalDist;
                                        // Richtung des naeheren Mitspielers wird errechnet (tan x = y => x = atan y)
                                        // Wertebereich: [-180; 180]
                                        closestTmDirToGoal = dir(aspieler.getX(), aspieler.getY(), myPos.getX(), myPos.getY());
                                    }
                                }
                            }
                            else { // ... ist ein Gegenspieler!
                            }
                            break;
                            
                        } // Ende case SPIELER
                        
                    } // Ende switch
                } // Ende for...Enumeration
                
                if (closestTmToGoalDistToMe<20) {
                    closerTmAvail = true;
                    availTmDir = 0.8f*closestTmDirToGoal;
                    availTmDist = closestTmToGoalDistToMe;
                }
                else {
                    if (closestTmDistToMe<20) {
                        closerTmAvail = true;
                        availTmDir = closestTmDirToMe;
                        availTmDist = closestTmDistToMe;
                    }
                    else { closerTmAvail = false; }
                }
                break;
            } // Ende case PLAY_ON
        }
        
        
        // ------------ Umsetzung des Aktivitaetsdiagramms "Stuermer" -------------
        
        //System.out.println("playStatus: "+myPlayer.getPlayStatus());
        //System.out.println("myPos: "+myPos.getX()+","+myPos.getY());
        //System.out.println("foundBall: "+foundBall);
        //System.out.println("ballPos: "+ballPos.getX()+","+ballPos.getY());
        //System.out.println("ballInRange: "+ballInRange);
        //System.out.println("ballDir: "+ballDir);
        //System.out.println("ballDist: "+ballDist);
        //System.out.println("bodyAngle: "+myPlayer.getBodyAngle());
        
        
        if (myPos.getX() > 53 || myPos.getX() < -53 || myPos.getY() > 34.5f || myPos.getY() < -34.5f) {
            if ((myPlayer.getBodyAngle()-MPDir>2) || (myPlayer.getBodyAngle()-MPDir<(-2))) {
                turnBodyTo(MPDir);
            }
            else myPlayer.dash(100);
        }
        else {
            
            switch (myPlayer.getPlayStatus()) {
                
                case Player.KICK_OFF_MYTEAM:
                case Player.KICK_OFF_OPP:
                    default:
                    {
                        
                        if ( myPlayer.getPlayTime()>0 && myPlayer.getPlayTime()<=6000 ) {
                            
                            if (myStartPos.getY()>0) poskorr = 1;
                            else poskorr = -1;
                            
                            // ist nicht auf Position vor gegn. Strafraum ??
                            if (dist(30, (poskorr*12), myPos.getX(), myPos.getY())>2) {
                                if (foundBall) {
                                    if (ballInRange) {
                                        if (oppGoalNear) {
                                            if (oppGoalDirOpt > 60 || oppGoalDirOpt < -60 && oppGoalDistC>5) { kickTo(60, dir(45, 0, myPos.getX(), myPos.getY())); }
                                            else { kickTo(100, oppGoalDirOpt); }
                                        }
                                        else {
                                            if (closerTmAvail) kickTo((int)(3*availTmDist), availTmDir);
                                            else kickTo(20, freeDir);
                                        }
                                    }
                                    else { // ball nicht in Range
                                        if (amNearestTmToBall && ballPos.getX()>2) {
                                            // gehe zu Ball
                                            if ( ((myPlayer.getBodyAngle()-ballDir))>=(-3) && ((myPlayer.getBodyAngle()-ballDir)<=3) ) {
                                                if (ballDist>3) {
                                                    myPlayer.dash(100);
                                                }
                                                else {
                                                    myPlayer.dash(70);
                                                }
                                            }
                                            else {
                                                turnBodyTo(ballDir);
                                                if (myPlayer.getReceivedSeeHead()) myPlayer.turnHead(-myPlayer.getHeadAngle());
                                            }
                                        }
                                        else { // nicht der naeheste am Ball
                                            goTo(30, (poskorr*12), 2);
                                            turnHeadTo(ballDir);
                                        }
                                    }
                                }
                                else { // ball nicht gefunden
                                    goTo(30, (poskorr*12), 2);
                                    searchBallWalk();
                                }
                            }
                            // ist auf Position vorm Strafraum...
                            else {
                                if (foundBall) {
                                    if (ballInRange) {
                                        if (oppGoalNear) {
                                            if (oppGoalDirOpt > 60 || oppGoalDirOpt < -60 && oppGoalDistC>5) { kickTo(60, dir(45, 0, myPos.getX(), myPos.getY())); }
                                            else { kickTo(100, oppGoalDirOpt); }
                                        }
                                        else {
                                            if (closerTmAvail) kickTo((int)(3*availTmDist), availTmDir);
                                            else kickTo(20, freeDir);
                                        }
                                    }
                                    else { // ball nicht in Range
                                        if (amNearestTmToBall && ballPos.getX()>0) {
                                            // gehe zu Ball
                                            if ( ((myPlayer.getBodyAngle()-ballDir))>=(-3) && ((myPlayer.getBodyAngle()-ballDir)<=3) ) {
                                                if (ballDist>3) {
                                                    myPlayer.dash(100);
                                                }
                                                else {
                                                    myPlayer.dash(70);
                                                }
                                            }
                                            else {
                                                turnBodyTo(ballDir);
                                                if (myPlayer.getReceivedSeeHead()) myPlayer.turnHead(-myPlayer.getHeadAngle());
                                            }
                                        }
                                        else { // nicht der naeheste am Ball
                                            // focus Ball
                                            turnBodyTo(ballDir);
                                            if (myPlayer.getReceivedSeeHead()) myPlayer.turnHead(-myPlayer.getHeadAngle());
                                        }
                                    }
                                }
                                else { // ball nicht gefunden
                                    searchBall();
                                }
                            }
                        }
                        break;
                    }
                    
                case Player.GOAL_KICK_OPP:
                {
                    if (foundBall) {
                        if ( ((myPlayer.getBodyAngle()-ballDir))>=(-3) && ((myPlayer.getBodyAngle()-ballDir)<=3) ) {
                            if (ballDist>15) {
                                myPlayer.dash(100);
                            }
                        }
                        else {
                            turnBodyTo(ballDir);
                            if (myPlayer.getReceivedSeeHead()) myPlayer.turnHead(-myPlayer.getHeadAngle());
                        }
                    }
                    else {
                        searchBall();
                    }
                    break;
                }
                
                case Player.FREE_KICK_OPP:
                case Player.KICK_IN_OPP:
                case Player.GOAL_KICK_MYTEAM:
                case Player.CORNER_KICK_OPP:
                case Player.CORNER_KICK_MYTEAM:
                {
                    if (dist(30, (poskorr*12), myPos.getX(), myPos.getY())>2) { goTo(30, (poskorr*12), 1); }
                    else {
                        if (!foundBall) {
                            searchBall();
                        }
                        else {
                            turnBodyTo(ballDir);
                            if ((myPlayer.getHeadAngle()>1 || myPlayer.getHeadAngle()<-1) && myPlayer.getReceivedSeeHead()) myPlayer.turnHead(-myPlayer.getHeadAngle());
                        }
                    }
                    break;
                }
                
                case Player.BEFORE_KICK_OFF:
                case Player.EXCEPTION:
                {
                    break;
                }
                
            }
        }
    }
}

